SystemOrganization addCategory: #ManifestoBrowser!

Object subclass: #LintRuleBrowser
	instanceVariableNames: 'head tree browser environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!LintRuleBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/4/2011 12:41'!
for: tree
	^self for:tree onEnvironment: BrowserEnvironment new! !

!LintRuleBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/4/2011 12:38'!
for: tree onEnvironment: env
	^self new tree:tree environment: env! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/7/2011 14:24'!
formatTree: a
	^a tree 
			title: 'Lint Rules'; 
			children: [ :x :i | x isLeaf ifTrue: [OrderedCollection new] ifFalse: [ x children ] ];
			rootsExpanded; 
			format: [ :node | self nodeDisplayName: node ];
			icon: [:node | self nodeDisplayIcon: node ];
			beMultiple;
			"act: [:p | p selection inspect ] icon: UITheme current smallInspectItIcon entitled: 'Inspect'; "
			act: [:p | p selection ifNotNilDo: [:sel | self runLint: sel ]] icon: UITheme current smallForwardIcon  entitled: 'Run rules';
			act: [:p | p selection ifNotNilDo: [:sel | sel do: [:each| tree remove: each]]. browser update ] icon: UITheme current smallDeleteIcon entitled: 'Remove';
			act: [:p | self openAddRuleDialog ] icon: UITheme current smallRightFlushIcon entitled: 'Add rules'
			! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:43'!
nodeDisplayIcon: node
	^node analized 
		ifTrue: [ node allAnalized 
						ifTrue: [ node problemCount = 0 
										ifTrue: UITheme current smallOkIcon  
										ifFalse: UITheme current smallErrorIcon ]
						ifFalse: [ node problemCount > 0 ifTrue: [UITheme current smallErrorIcon] ]]! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:51'!
nodeDisplayName: node
	^node name , ' ', 
	(node analized 
			ifTrue: '(',node problemCount printString, (node allAnalized ifTrue:[''] ifFalse:[' partially']),')' 
			ifFalse: '')! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/7/2011 14:47'!
open
	"(LintRuleBrowser for:(LintRuleTree for: RBCompositeLintRule lintChecks) onEnvironment: (BrowserEnvironment new forPackageNames: #('Mondrian-Core'))) open"

	browser := GLMTabulator new.	
	browser title: self title.
	browser 
		column: #rules;
		column: #preview. 
		
	browser transmit to: #rules; andShow: [ :a | 
		self formatTree: a].
		      
	browser transmit to: #preview; from: #rules; andShow: [ :a |
		a text
			title: 'Results';
			when: [:x| (x size = 1) and: ((x atWrap:1) isLeaf )];
			display: [ :x | ((x atWrap:1) rule asNode update: (BrowserEnvironment new)) text];
			act: [:x | (x entity atWrap: 1) rule class browse ] icon: UITheme current smallInspectItIcon entitled: 'Inspect'
			 ].
		
	browser openOn: tree head children! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:56'!
openAddRuleDialog

	| finder validator |
	
	finder := GLMFinder new.
	validator := GLMValidator new.
	validator show: [:a | 
		a tree 
			title: 'Lint-Check Rules';
			beMultiple; 
			children: [ :node :i | node isLeaf ifTrue:[OrderedCollection new] ifFalse: [ node children  ] ];
			rootsExpanded; 
			format: [ :node | node name ]].
	validator validator: 'Ok' act: [:x | x selection ifNotNilDo: [:sel | tree addNodes: sel]. x close. browser update ].
		
	finder show: [:a | a custom: validator].
	finder openOn: ((LintRuleTree for: (RBCompositeLintRule lintChecks)) removeNodesIn:tree) head children! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:43'!
runLint: selectedNodes
	SmalllintChecker 
		runRule: (RBCompositeLintRule rules: (selectedNodes collect:[:each | each toRule ])) 
		onEnvironment: environment. selectedNodes do: [:each | each analized:true]. 
	browser update! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/4/2011 16:13'!
title
	^'Lint Browser for ',(environment packages collect:[:each | each packageName ]) asCommaString! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:21'!
tree
	^tree! !

!LintRuleBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:42'!
tree:t environment: env
	tree:= t.
	environment  := env! !

LintRuleBrowser subclass: #LintRulePackageBrowser
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!LintRulePackageBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 23:46'!
forPackageName: n
	^self new package: n ! !

!LintRulePackageBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 14:05'!
formatTree: a
	^(super formatTree: a) act: [:p | self saveTree ] icon: UITheme current smallSaveIcon  entitled: 'Save tree'! !

!LintRulePackageBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/7/2011 10:08'!
package: packageName
	| pack t |
	package := packageName.
	
	pack := RPackageOrganizer default packageNamed: packageName.
	(ManifestoBrowser hasManisfesto: pack)
		ifTrue:  [
			(ManifestoBrowser manifestoOf: pack) rules
			ifNotNilDo: [: leaves | |leaves2|
			t := (LintRuleTree for: RBCompositeLintRule lintChecks).
			leaves2 := t head leaves.
			leaves2 removeAllSuchThat:[: each | (leaves findFirst:[:each2| (each2 compare: each name) ==2]) > 0 ].
			leaves2 do: [:each | t head removeNamed: each name]
			]	 
		].
	
	t ifNil: [ t:= (LintRuleTree for: RBCompositeLintRule lintChecks)].
	
	^ super
		tree: t
		environment: (BrowserEnvironment new forPackageNames: (Array with: packageName))! !

!LintRulePackageBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 18:20'!
saveTree
	| pack t |
	pack := RPackageOrganizer default packageNamed: package.
	(ManifestoBrowser hasManisfesto: pack)
		ifFalse: [ ManifestoBrowser createManifesto: package ].
		
	"(ManifestoBrowser manifestoOf: pack) ruleTree: tree"
	
	(ManifestoBrowser manifestoOf: pack) class removeSelector:  #rules.
	(ManifestoBrowser manifestoOf: pack) class compile: 'rules 
		^', ((tree head leaves collect:[:each | each name]) storeString)
		
	 
	! !

Object subclass: #LintRuleNode
	instanceVariableNames: 'name children rule analized parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:40'!
addChild: node
	children ifNil: [children := LinkedList new].
	children add: node.
	node parent: self! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:39'!
allAnalized
	self isLeaf 
		ifTrue: [analized isNil ifTrue: [^false] ifFalse: [^analized]] 
		ifFalse:[children do:[: each | each analized ifFalse: [^false]]. ^true]  ! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:39'!
allRules
	| allRules |
	self isLeaf 
		ifTrue: [^Array with: self rule] 
		ifFalse:[ allRules := LinkedList new. 
				children do: [:each| each allRules do: [:each2 | allRules add: each2]]. ^allRules]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:39'!
analized
	self isLeaf 
		ifTrue: [analized isNil ifTrue: [^false] ifFalse: [^analized]] 
		ifFalse:[children do:[: each | each analized ifTrue: [^true]]. ^false]  ! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:39'!
analized: v
	self isLeaf 
		ifTrue: [analized := v] 
		ifFalse:[children do:[:each | each analized:v]]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:15'!
children
	^children! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:40'!
children: c
	children := c! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:40'!
isLeaf
	^children isNil! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:41'!
leaves
	| leaves |
	leaves := LinkedList new.
	self isLeaf 
		ifTrue: [leaves add: self] 
		ifFalse: [self children do:[:each | each leaves do:[:each2| leaves add: each2]]].
	^leaves! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:14'!
name
	^name! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:41'!
name: s
	name := s! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 09:16'!
parent
	^parent! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:48'!
parent: node
	parent := node! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:41'!
problemCount
	| count |
	self isLeaf 
		ifTrue: [^self rule problemCount ] 
		ifFalse: [count := 0. children do: [:each | count := count + each problemCount]. ^count]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 10:32'!
remove: node
	self isLeaf 
		ifFalse:[
			children remove: node ifAbsent: [ children do: [:each | each remove: node]].
			children isEmpty ifTrue:[parent ifNotNilDo: [:p | p remove:self]]
		]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 10:30'!
removeNamed:  aName
	self isLeaf 
		ifFalse:[
			children removeAllSuchThat: [:each | (each name compare: aName) = 2]. 
			children do: [:each | each removeNamed: aName].
			children isEmpty ifTrue:[parent ifNotNilDo: [:p | p remove:self]]
		]! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 22:11'!
rule
	^rule! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 22:12'!
rule: r
	rule := r! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 17:50'!
storeString
	"LintRuleNode new name: 'n1';
		addChild: (LintRuleNode new name: 'n2');
		addChild: (LintRuleNode new name: 'n3')"

	^ 'LintRuleNode new name: ''', name,'''',
	    (self isLeaf 
		ifTrue: ['']
		ifFalse: [';', 
			(String streamContents: 
					[:s | (children collect:[:each | 'addChild: (', each storeString ,')' ]) asStringOn: s delimiter: ';']
			)])! !

!LintRuleNode methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 23:03'!
toRule

	^ RBCompositeLintRule rules: self allRules! !

Object subclass: #LintRuleTree
	instanceVariableNames: 'head'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!LintRuleTree class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 16:31'!
for: rule
	"LintRuleTree for: RBCompositeLintRule lintChecks"

	| node |
	node := LintRuleNode new name: 'Dummy'.
	node addChild: (self toNode: rule).
	^self new head: node! !

!LintRuleTree class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 22:12'!
toNode: rule
	| node |
	node := LintRuleNode new name: rule name.
	rule isComposite ifTrue:[ rule rules do: [:each | node addChild: (self toNode: each)]] ifFalse: [ node rule: rule].
	^ node.! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 10:28'!
addNodes: nodes
	nodes do: [:each | 
		(self searchNamed: each parent name) ifNil: [
		|n parent | n := (self searchNamed: each parent parent name).
		 parent := LintRuleNode new name: each parent name.
		 parent addChild: each.
		 n addChild: parent

		] ifNotNilDo: [:n | n addChild: each] ]! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:14'!
head
	^head! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:13'!
head: node
	head := node! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 09:58'!
leaves
	^head leaves! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 9/30/2011 21:47'!
remove: node
	head remove: node! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/5/2011 15:33'!
removeNamed: aName
	head removeNamed: aName! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 10:14'!
removeNodesIn: aTree
	| leaves |
	leaves := aTree leaves.
	
	leaves do:[:each| self removeNamed: each name].
	^self 
	! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 09:07'!
searchNamed: name
	
	^self searchNamed: name in:head! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/1/2011 09:49'!
searchNamed: name in: node
	
	| v |
	((node name compare: name) = 2)
		ifTrue: [^node] 
		ifFalse: [ node isLeaf 
			ifFalse: [node children do: [:each | v := self searchNamed: name in: each. v ifNotNilDo: [:n|^v]]]].
	^nil. ! !

!LintRuleTree methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 17:56'!
storeString
	"LintRuleTree new head: ((LintRuleNode new name: 'Dummy') addChild:
		(LintRuleNode new name: 'n1';
			addChild: (LintRuleNode new name: 'n2');
			addChild: (LintRuleNode new name: 'n3')))"

	^ 'LintRuleTree new head: ((LintRuleNode new name: ''Dummy'') addChild: (', head storeString,'))'  ! !

Object subclass: #ManifestoBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AN 10/10/2011 12:45'!
createManifesto: packageName

	| package cls |
	
	package := (RPackageOrganizer default packageNamed: packageName).
	
	
	cls := (Object subclass: (ManifestoBrowser manifestoNameOfPackageNamed: packageName) asSymbol 
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: packageName
	).
	
	cls class instanceVariableNames: ''.
	cls class compile: 'rules
		^nil'.
	cls class compile: 'packageDescription
					^'''''.! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
hasManisfesto: aPackage
	"this should be an extension method dfined on the class RPackage"
	
	| manisfestoName |
	manisfestoName := self manifestoNameOf: aPackage.
	^ aPackage classes anySatisfy: [ :aClass | aClass name = manisfestoName ]! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/7/2011 14:58'!
icon
	^UITheme current smallForwardIcon! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
manifestoNameOf: aPackage

	^ 'Manifesto', (aPackage name copyWithout: $-)! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 12:03'!
manifestoNameOfPackageNamed: packageName

	^ 'Manifesto', (packageName copyWithout: $-)! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
manifestoOf: aPackage

	^ Compiler evaluate: (self manifestoNameOf: aPackage)! !

!ManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/7/2011 14:57'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #'ManifestoBrowser')
		order: 6; 
		parent: #Tools;
		label: 'Manifesto Browser';
		icon: self icon;
		action:[ManifestoBrowser open]! !

!ManifestoBrowser class methodsFor: 'public' stamp: 'AngelNunez 9/28/2011 13:43'!
open
	"Open a browser"
	^ self new open! !

!ManifestoBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/10/2011 10:38'!
authors: x
	|s| 
	^(((RPackageOrganizer default packageNamed: (x)) methods  
		collect: [ :cm| s := cm timeStamp substrings. s isEmpty ifTrue:[''] ifFalse:[ s first ]]) asSet)! !

!ManifestoBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
description: packageName
	| package | 
	
	package := RPackageOrganizer default packageNamed: packageName.
	
	^(ManifestoBrowser hasManisfesto: package) 
		ifTrue: [(ManifestoBrowser manifestoOf: package) packageDescription ifNil: [''] ifNotNilDo:[:d|d] ] 
		ifFalse:['']! !

!ManifestoBrowser methodsFor: 'opening' stamp: 'AngelNunez 10/10/2011 10:21'!
open
	"self new open"

	^ self openOn: self sortedPackages! !

!ManifestoBrowser methodsFor: 'opening' stamp: 'AngelNunez 10/10/2011 10:37'!
openOn: aPackageList
	"self new open "
	
	| browser |
	
	browser := GLMTabulator new.
	browser title: 'Manifesto Browser'.
	browser 
		column: #packages; 
		column: #manifesto.
	
	browser transmit to: #packages;andShow: [ :a | a list
		title: 'Package';
		beSingle;
		act: [:x |
			x selection ifNotNilDo: [:packageName | (LintRulePackageBrowser forPackageName: packageName ) open ]] 
		icon: UITheme current smallForwardIcon entitled: 'Open Lint Browser'.].
		
	browser transmit 
		to: #manifesto; 
		from: #packages; 
		andShow: [ :a | 
			a stackedVerticallyArrangement.
			a list title: 'Authors';
				display: [ :x | self authors: x ].
			a text title: 'Description';
				display: [:x| self description: x ];
				act: [:x | self saveDescription:x entity description: x text ] 
				icon: UITheme current smallSaveIcon  entitled: 'Save description' ].
	
	browser openOn: (aPackageList collect:[:each | each name])! !

!ManifestoBrowser methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 16:18'!
saveDescription: packageName description: description
	| pack t |
	pack := RPackageOrganizer default packageNamed: packageName.
	(ManifestoBrowser hasManisfesto: pack)
		ifFalse: [ ManifestoBrowser createManifesto: packageName ].
	
	(ManifestoBrowser manifestoOf: pack) class removeSelector:  #packageDescription.
	(ManifestoBrowser manifestoOf: pack) class compile: 'packageDescription 
		^''', description,''''! !

!ManifestoBrowser methodsFor: 'util' stamp: 'AngelNunez 9/28/2011 14:06'!
sortedPackages
	^ RPackageOrganizer default packages asSortedCollection: [ :a :b | a name <= b name ]! !

Object subclass: #ManifestoManifestoBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!ManifestoManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AN 10/10/2011 12:44'!
packageDescription 
		^''! !

!ManifestoManifestoBrowser class methodsFor: 'as yet unclassified' stamp: 'AN 10/10/2011 12:40'!
rules 
		^#('#asOrderedCollection/#asArray not needed' 'Doesn''t use the result of a yourself message' 'Excessive inheritance depth' 'Excessive number of arguments' 'Excessive number of methods' 'Excessive number of variables' 'Inconsistent method classification' 'Inspect instances of "A + B * C" might be "A + (B * C)"' 'Instance variables defined in all subclasses' 'Long methods' 'No class comment' 'Non-blocks in special messages' 'Redundant class name in selector' 'Refers to class name instead of "self class"' 'Sends "questionable" message' 'String concatenation instead of streams' 'Unclassified methods' 'Unnecessary assignment or return in block' 'Uses "(a and: [b]) and: [c]" instead of "a and: [b and: [c]]"' 'Uses (to:)do: instead of to:do:' 'Utility methods' 'Variable is only assigned a single literal value' 'Argument variable names' 'Class categories' 'Class comments' 'Class names' 'Class variable names' 'Instance variable names' 'Literal values' 'Method comments' 'Method protocols' 'Method selectors' 'Temporary variable names' 'An opposite attribute declared in pragma does not point back to the initial attribute' 'An opposite class declared in pragma #MSEProperty:type:opposite: does not exist' 'FM3 class doesnt respect the fame name convention between FM3 and Smalltalk ' 'The superclass defined in a FM3MetaDescription does not exist or is not well defined' 'Assignment has no effect' 'Block immediately evaluated' 'Check for same statements at end of ifTrue:ifFalse: blocks' 'Class not referenced' 'Instance variables not read AND written' 'Method just sends super message' 'Methods equivalently defined in superclass' 'Methods implemented but not sent' 'Temporary variables not read AND written' 'Unnecessary "= true"' 'Unnecessary assignment to a temporary variable' 'Variable referenced in only one method and always assigned first' 'Variables not referenced' 'Class variable capitalization' 'Doesn''t use the result of a collect:/select:' 'Guarding clauses' 'Instance variable capitalization' 'Law of demeter' 'Literal array contains only characters' 'Method defined in all subclasses, but not in superclass' 'Sends add:/remove: to external collection' 'Temporary variable capitalization' 'Unnecessary size check' 'Uses "size = 0", "= nil",  or "at: 1" instead of "isEmpty",  "isNil", or "first"' 'Uses detect:ifNone: instead of contains:' 'Uses do: instead of collect: or select:''s' 'Uses do: instead of contains: or detect:''s' 'Uses or''s instead of a searching literal' 'Uses to:do: instead of do:, with:do: or timesRepeat:' 'Uses whileTrue: instead of to:do:' 'ifTrue:/ifFalse: returns instead of and:/or:''s' 'to:do: doesn''t use collect:' 'to:do: loop also increments a counter' 'Invalid use of deprecated API protocol.' 'Debugging code left in methods' 'Menus missing translations' 'Method has no timeStamp' 'Method source contains linefeeds' 'Platform dependent user interaction' 'Sends a deprecated message to a known global' 'Sends super new initialize' 'Messages sent but not implemented' 'Missing super implementation' 'Overrides a "special" message' 'Overrides a final method' 'References an undeclared variable' 'Sends unknown message to global' 'Subclass responsibility not defined' 'Super call required' 'Uses A | B = C instead of A | (B = C)' 'Uses True/False instead of true/false' 'Variable used, but not defined anywhere' 'Assignment inside unwind blocks should be outside.' 'Contains a return in an ensure: block' 'Defines = but not hash' 'Doesn''t use the result of a =, ~=, etc.' 'Empty exception handler' 'Float equality comparison' 'Has class instance variables but no initialize method' 'Instance variable overridden by temporary variable' 'Literal array contains a #,' 'Literal array contains a #true, #false, or #nil but the source doesn''t.' 'Missing super sends in selected methods.' 'Modifies collection while iterating over it' 'Number of addDependent: messages > removeDependent:' 'Possible missing "; yourself"' 'Possible three element point (e.g., x @ y + q @ r)' 'References an abstract class' 'Returns a boolean and non boolean' 'Returns value of ifTrue:/ifFalse: without ifFalse:/ifTrue: block' 'Sends different super message' 'Subclass of collection that has instance variable but doesn''t define copyEmpty' 'Temporaries read before written' 'Uncommon message send' 'Unconditional recursion' 'Unpackaged code' 'Uses the result of an add: message' 'A metamodel class does not override a method that it should override' 'A metamodel class is not properly Fame-described by a <MSEClass:super:> pragma' 'A metamodel class override a method that it should not override' '#basicNew initialize is missing' 'Empty Statements' 'Invalid object initialization' 'Non portable source format' 'Uses curly brace arrays' 'Uses its class for hash' 'Uses literal byte arrays' 'Uses method annotations' 'Uses not portable class' )! !

TestCase subclass: #ManifestoBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ManifestoBrowser'!

!ManifestoBrowserTest methodsFor: 'util' stamp: 'AngelNunez 9/28/2011 14:27'!
packageName
	^ 'ManifestoBrowser'! !

!ManifestoBrowserTest methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
testHasManisfesto

	| aPackage browser |
	browser := ManifestoBrowser new.

	aPackage := (RPackageOrganizer default packageNamed: self packageName).
	self assert: (browser hasManisfesto: aPackage).

	aPackage := (RPackageOrganizer default packageNamed: 'Kernel-Classes').
	self deny: (browser hasManisfesto: aPackage).
! !

!ManifestoBrowserTest methodsFor: 'as yet unclassified' stamp: 'AngelNunez 10/6/2011 15:36'!
testManisfestoName

	| browser aPackage |
	browser := ManifestoBrowser new.
	aPackage := RPackageOrganizer default packageNamed: 'Kernel-Classes'.
	self assert: (browser manifestoNameOf: aPackage) = 'ManifestoKernelClasses'.
	
	aPackage := RPackageOrganizer default packageNamed: 'Announcements-Tests-Core'.
	self assert: (browser manifestoNameOf: aPackage) = 'ManifestoAnnouncementsTestsCore'! !
